using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DatabasedAlarmUI
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmDatabasedAlarmUI : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridAlarmDetails;
		private System.Windows.Forms.CheckBox chkBeepOnOff;
		private System.Windows.Forms.CheckBox chkAlarmOnOff;
		private System.Windows.Forms.Button btnAdd;
		private System.Windows.Forms.Button btnDelete;
		private System.Windows.Forms.Button btnSave;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		// Contain Grid data
		private System.Data.DataTable m_AlarmDetailsTable;

		#region Constant
		private const int DeleteColIndex = 1;
		private const int ChannelCodeColIndex = 2;
		private const int DomainColIndex = 3;
		private const int LowerWarningColIndex = 4;
		private const int UpperWarningColIndex = 5;
		private const int LowerErrorColIndex = 6;
		private const int UpperErrorColIndex = 7;
		private const int UnitColIndex = 8;
		private const int AlarmColIndex = 9;
		private const int BeepColIndex = 10;
		private const int DisplayDataGuageColIndex = 11;
		private const int TimeDelayColIndex = 12;
		private const int DepthDelayColIndex = 13;
		#endregion

		public frmDatabasedAlarmUI()
		{
			//
			// Required for Windows Form Designer support
			//
			m_AlarmDetailsTable = new DataTable();
			InitializeComponent();

			setGridProperties();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridAlarmDetails = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			this.chkBeepOnOff = new System.Windows.Forms.CheckBox();
			this.chkAlarmOnOff = new System.Windows.Forms.CheckBox();
			this.btnAdd = new System.Windows.Forms.Button();
			this.btnDelete = new System.Windows.Forms.Button();
			this.btnSave = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridAlarmDetails)).BeginInit();
			this.SuspendLayout();
			// 
			// gridAlarmDetails
			// 
			this.gridAlarmDetails.ActivateCurrentCellBehavior = Syncfusion.Windows.Forms.Grid.GridCellActivateAction.SelectAll;
			this.gridAlarmDetails.AllowDragSelectedCols = true;
			this.gridAlarmDetails.ForeColor = System.Drawing.SystemColors.ControlText;
			this.gridAlarmDetails.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.MultiExtended;
			this.gridAlarmDetails.Location = new System.Drawing.Point(3, 56);
			this.gridAlarmDetails.MinResizeColSize = 3;
			this.gridAlarmDetails.MinResizeRowSize = 3;
			this.gridAlarmDetails.Name = "gridAlarmDetails";
			this.gridAlarmDetails.Properties.RowHeaders = false;
			this.gridAlarmDetails.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridAlarmDetails.Size = new System.Drawing.Size(590, 170);
			this.gridAlarmDetails.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.SingleClick;
			this.gridAlarmDetails.TabIndex = 0;
			this.gridAlarmDetails.Text = "gridDataBoundGrid1";
			this.gridAlarmDetails.ThemesEnabled = true;
			this.gridAlarmDetails.CurrentCellChanged += new System.EventHandler(this.gridAlarmDetails_CurrentCellChanged);
			this.gridAlarmDetails.CheckBoxClick += new Syncfusion.Windows.Forms.Grid.GridCellClickEventHandler(this.gridAlarmDetails_CheckBoxClick);
			this.gridAlarmDetails.PrepareViewStyleInfo += new Syncfusion.Windows.Forms.Grid.GridPrepareViewStyleInfoEventHandler(this.gridAlarmDetails_PrepareViewStyleInfo);
			// 
			// chkBeepOnOff
			// 
			this.chkBeepOnOff.Location = new System.Drawing.Point(8, 16);
			this.chkBeepOnOff.Name = "chkBeepOnOff";
			this.chkBeepOnOff.TabIndex = 1;
			this.chkBeepOnOff.Text = "Beep ON/OFF";
			// 
			// chkAlarmOnOff
			// 
			this.chkAlarmOnOff.Location = new System.Drawing.Point(168, 16);
			this.chkAlarmOnOff.Name = "chkAlarmOnOff";
			this.chkAlarmOnOff.TabIndex = 2;
			this.chkAlarmOnOff.Text = "Alarm ON/OFF";
			// 
			// btnAdd
			// 
			this.btnAdd.Location = new System.Drawing.Point(72, 240);
			this.btnAdd.Name = "btnAdd";
			this.btnAdd.TabIndex = 3;
			this.btnAdd.Text = "Add";
			this.btnAdd.Click += new System.EventHandler(this.btnAdd_Click);
			// 
			// btnDelete
			// 
			this.btnDelete.Location = new System.Drawing.Point(248, 240);
			this.btnDelete.Name = "btnDelete";
			this.btnDelete.TabIndex = 4;
			this.btnDelete.Text = "Delete";
			// 
			// btnSave
			// 
			this.btnSave.Location = new System.Drawing.Point(432, 240);
			this.btnSave.Name = "btnSave";
			this.btnSave.TabIndex = 5;
			this.btnSave.Text = "Save";
			// 
			// frmDatabasedAlarmUI
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(592, 273);
			this.Controls.Add(this.btnSave);
			this.Controls.Add(this.btnDelete);
			this.Controls.Add(this.btnAdd);
			this.Controls.Add(this.chkAlarmOnOff);
			this.Controls.Add(this.chkBeepOnOff);
			this.Controls.Add(this.gridAlarmDetails);
			this.Name = "frmDatabasedAlarmUI";
			this.Text = "Data based Alaram UI";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridAlarmDetails)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#region Initialization methods
		/// <summary>
		/// Create Data Table and link grid to data table.
		/// Set Grid properties
		/// </summary>
		private void setGridProperties()
		{
			m_AlarmDetailsTable.Columns.AddRange(
				new DataColumn[]{
									new DataColumn("Delete",typeof(bool)),
									new DataColumn("Channel Code",typeof(string)),
									new DataColumn("Domain",typeof(string)),
									new DataColumn("Lower Warning",typeof(string)),
									new DataColumn("Upper Warning",typeof(string)),
									new DataColumn("Lower Error",typeof(string)),
									new DataColumn("Upper Error",typeof(string)),
									new DataColumn("Unit",typeof(string)),
									new DataColumn("Alarm",typeof(bool)),
									new DataColumn("Beep",typeof(bool)),
									new DataColumn("Display Data Gauge",typeof(bool)),
									new DataColumn("Time Delay",typeof(string)),
									new DataColumn("Depth Delay",typeof(string))}
									);

			m_AlarmDetailsTable.Clear();

			// Alarm Details grid
			gridAlarmDetails.DataSource = m_AlarmDetailsTable;
			gridAlarmDetails.AllowResizeToFit = true;
			gridAlarmDetails.ThemesEnabled = true;
			gridAlarmDetails.ExcelLikeSelectionFrame = false;
			gridAlarmDetails.ExcelLikeCurrentCell = false;
			gridAlarmDetails.MinResizeColSize = 100;
			gridAlarmDetails.ExcelLikeSelectionFrame = false;
			//gridAlarmDetails.TableStyle.CheckBoxOptions = new Syncfusion.Windows.Forms.Grid.GridCheckBoxCellInfo("True", "False", "", true);


		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmDatabasedAlarmUI());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
		
		}

		private void gridAlarmDetails_PrepareViewStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.GridPrepareViewStyleInfoEventArgs e)
		{
			try
			{
				//show tool tips for truncated text
				if ( e.ColIndex > 0 && e.RowIndex > 0 )
				{
					
					e.Style.CellTipText = "";

					if(gridAlarmDetails.Model.ColWidths[e.ColIndex] - e.Style.TextMargins.Left 
						- e.Style.TextMargins.Right < CreateGraphics().MeasureString(e.Style.Text,e.Style.GdipFont).Width)
						e.Style.CellTipText = e.Style.Text;

					switch (e.ColIndex)
					{
						case DeleteColIndex :
						case AlarmColIndex :
						case BeepColIndex :
						case DisplayDataGuageColIndex :
							e.Style.CellType = "CheckBox";
							e.Style.CellValueType = typeof(bool);
							e.Style.CellValue = true;
							e.Style.TriState = false;
							e.Style.Clickable = true;
							e.Style.Enabled = true;
							e.Style.CheckBoxOptions.CheckedValue = "True";
							e.Style.CheckBoxOptions.UncheckedValue = "False";
							break;

						case ChannelCodeColIndex :
						case DomainColIndex :
						case LowerWarningColIndex :
						case UpperWarningColIndex :
						case LowerErrorColIndex :
						case UpperErrorColIndex :
						case UnitColIndex:
						case TimeDelayColIndex :
						case DepthDelayColIndex :
							e.Style.CellType = "Static";
							e.Style.ReadOnly = true;
							e.Style.CellTipText = gridAlarmDetails[e.RowIndex,e.ColIndex].Text;
							break;

					}
				}

				if((e.ColIndex != 0) && (e.RowIndex != 0))
				{
				}
			}
			catch(Exception ex)
			{
				MessageBox.Show("in view " + ex.Message.ToString());
			}
		}

		private void PopulateGrid()
		{
			m_AlarmDetailsTable.LoadDataRow(new object[]{
															true,
															"Channel1",
															"Depth",
															"10","100","200", "200",
															"m", 
															true, false,true,
															"10", "20"}
											,true);

			m_AlarmDetailsTable.LoadDataRow(new object[]{
															true,
															"Channel2",
															"Time",
															"10","100","200", "200",
															"m", 
															false, true,false,
															"10", "20"}
				,true);

			gridAlarmDetails.Refresh();		


		}

		private void btnAdd_Click(object sender, System.EventArgs e)
		{
			PopulateGrid();
		}

		
		void gridAlarmDetails_ModelQueryCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventArgs e)
		{
//			if ( e.RowIndex > 0)
//			{
//				int colIndex = e.ColIndex;
//			
//				// Unbound checkbox header column
//				if (colIndex == 1)
//				{
//					// Save checkbox value in hashtable
//					string key = GetPrimaryKey(e.RowIndex);
//					if (key != null)
//					{
//						e.Style.CellValue = ! (bool)e.Style.CellValue;
//					}
//					e.Handled = true;
//				}
//			}
			return;
		}

		private void gridAlarmDetails_CheckBoxClick(object sender, Syncfusion.Windows.Forms.Grid.GridCellClickEventArgs e)
		{
			return;
		}

		private void gridAlarmDetails_CurrentCellChanged(object sender, System.EventArgs e)
		{
			//			if ( e.RowIndex > 0)
//			{
//				int colIndex = e.ColIndex;
//			
//				// Unbound checkbox header column
//				if (colIndex == 1)
//				{
//					// Save checkbox value in hashtable
//					string key = GetPrimaryKey(e.RowIndex);
//					if (key != null)
//					{
//						e.Style.CellValue = ! (bool)e.Style.CellValue;
//					}
//					e.Handled = true;
//				}
//			}
		
		}
	}
}
